#:kivy 2.0.0
WindowManager:
    MainMenu:
    ChooseOptions:
    Ip:
    Broadcast:
    Netmask:
    MinHost:
    Wildcard:
    MaxHost:
    Network:
    Details:

<MainMenu>:
    name: "menu"
    MDBoxLayout:
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size
        orientation: "vertical"
        spacing: "2dp"
        # Titulo 1
        MDLabel:
            bold: True
            font_size: "50dp"
            text: "CIDR IP Address Calculator"
            valign: "top"
            halign: "center"
            color: 72/255,52/255,23/255,1
        # Titulo 2
        MDLabel:
            bold: True
            font_size: "40dp"
            text: "Insert IP Address"
            valign: "top"
            halign: "center"
            color: 72/255,52/255,23/255,1
        
        MDGridLayout:
            cols: 4
            spacing: '20dp'
            padding: ['65dp', '0dp', '65dp', '0dp']
            MDTextField:
                helper_text: "Max length 3"
                helper_text_mode: "on_focus"
                text: root.ip1
                id: txt_ip1
                mode: "line"
                halign: 'center' 
                on_double_tap: txt_ip1.text=""
            MDTextField:
                helper_text: "Max length 3"
                helper_text_mode: "on_focus"
                text: root.ip2
                id: txt_ip2
                mode: "line"
                halign: 'center'
                on_double_tap: txt_ip2.text=""
            MDTextField:
                helper_text: "Max length 3"
                helper_text_mode: "on_focus"
                text: root.ip3
                id: txt_ip3
                mode: "line"
                halign: 'center' 
                on_double_tap: txt_ip3.text=""
            MDTextField:
                helper_text: "Max length 3"
                helper_text_mode: "on_focus"
                text: root.ip4
                id: txt_ip4
                mode: "line"
                halign: 'center' 
                on_double_tap: txt_ip4.text=""

        MDBoxLayout:
            orientation: "vertical"
            # Titulo 3
            MDLabel:
                bold: True
                id: titulo3
                font_size: "40dp"
                text: "Prefix length"
                valign: "center"
                halign: "center"
                color: 72/255,52/255,23/255,1
            MDBoxLayout:
                orientation: "vertical"
                padding: ['150dp', '-10dp', '150dp', '0dp']
                MDTextField:
                    text: root.textSubnet
                    id: subnet
                    mode: "line"
                    pos_hint: {'center_x':.5, 'y':1}
                    helper_text: "Value between 1 and 32"
                    helper_text_mode: "on_focus"
                    on_double_tap: subnet.text=""
                    halign: 'center'       
        
        AnchorLayout:
            # Boton de navegacion para calcular
            MDRaisedButton:
                id: btn_calculate
                text: "Calculate"
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    if root.validateTransition():\
                    app.root.current = "choose"
                    root.manager.transition.direction = "left"
                    

<ChooseOptions>:
    name: "choose"
    MDBoxLayout:
        orientation: 'vertical'
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size
        padding: ['20dp', '0dp', '20dp', '0dp']
        spacing:"10dp"
        # Titulo 1
        MDLabel:
            bold: True
            valign: "top"
            font_style:"H4"
            text: "CIDR IP Address Calculator \n Choose an Option"
            valign: "top"
            halign: "center"
            color: 72/255,52/255,23/255,1
    #Botones
        MDGridLayout:
            cols: 2
            spacing: '20dp'
            padding: ['0dp', '-20dp', '0dp', '-100dp']
            # Buttons
            # IP
            Button:
                id: btn_calculate
                text: "IP Address"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "ip"
                    root.manager.transition.direction = "left"
            # Broadcast
            Button:
                id: btn_calculate
                text: "Broadcast\nAddress"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "broadcast"
                    root.manager.transition.direction = "left"   
            
            # Netmask
            Button:
                id: btn_calculate
                text: "Netmask"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "netmask"
                    root.manager.transition.direction = "left"
            # Minimum Host
            Button:
                id: btn_calculate
                text: "Minimum Host\nAddress"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "minhost"
                    root.manager.transition.direction = "left"

            # Wildcard
            Button:
                id: btn_calculate
                text: "Wildcard"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "wildcard"
                    root.manager.transition.direction = "left"
            # Maximum Host
            Button:
                id: btn_calculate
                text: "Maximum Host\nAddress"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "maxhost"
                    root.manager.transition.direction = "left"

            # Network
            Button:
                id: btn_calculate
                text: "Network\nAddress"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "network"
                    root.manager.transition.direction = "left"
            # Details
            Button:
                id: btn_calculate
                text: "Details"
                bold: True
                font_style: "H6"
                halign: "center"
                background_normal: ''
                background_color: (122/255, 177/255, 55/255, 1)
                on_press:
                    app.root.current = "details"
                    root.manager.transition.direction = "left"
        
        AnchorLayout:
            padding: ['0dp', '100dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to main menu"
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                on_press:
                    app.root.current = "menu"
                    root.manager.transition.direction = "right"
        

<Ip>:
    name: "ip"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size
        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1

        MDBoxLayout:
            orientation: 'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "IP Address:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: number
                font_size: "17dp"
                text: root.number
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaIP
                font_size: "17dp"
                text: root.hexaIP
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryIP
                font_size: "17dp"
                text: root.binaryIP
                halign: "left"
                color: 72/255,52/255,23/255,1
        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<Broadcast>:
    name: "broadcast"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Broadcast Address: "
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberBroadcast
                font_size: "17dp"
                text: root.numberBroadcast
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaBroadcast
                font_size: "17dp"
                text: root.hexaBroadcast
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryBroadCast
                font_size: "17dp"
                text: root.binaryBroadCast
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '40dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"


<Netmask>:
    name: "netmask"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Netmask: "
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberNet
                font_size: "17dp"
                text: root.numberNet
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaNet
                font_size: "17dp"
                text: root.hexaNet
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryNet
                font_size: "17dp"
                text: root.binaryNet
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<MinHost>:
    name: "minhost"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Minimum Host Address:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberMinH
                font_size: "17dp"
                text: root.numberMinH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaMinH
                font_size: "17dp"
                text: root.hexaMinH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryMinH
                font_size: "17dp"
                text: root.binaryMinH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<Wildcard>:
    name: "wildcard"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Wildcard:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberWild
                font_size: "17dp"
                text: root.numberWild
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal: "
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaWild
                font_size: "17dp"
                text: root.hexaWild
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary: "
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryWild
                font_size: "17dp"
                text: root.binaryWild
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<MaxHost>:
    name: "maxhost"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Maximum Host Address:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberMaxH
                font_size: "17dp"
                text: root.numberMaxH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaMaxH
                font_size: "17dp"
                text: root.hexaMaxH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryMaxH
                font_size: "17dp"
                text: root.binaryMaxH
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<Network>:
    name: "network"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size
        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Network Address:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Number
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Dotted-decimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: numberNetwork
                font_size: "17dp"
                text: root.numberNetwork
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Hexa
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Hexadecimal:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: hexaNetwork
                font_size: "17dp"
                text: root.hexaNetwork
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Binary
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Binary:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: binaryNetwork
                font_size: "17dp"
                text: root.binaryNetwork
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '40dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"

<Details>:
    name: "details"
    on_enter: root.start()
    BoxLayout:
        orientation: 'vertical'
        height: self.minimum_height
        canvas:
            Color:
                rgba: 227/255, 240/255, 171/255, 0.43
            Rectangle:
                pos: self.pos
                size: self.size

        # Titulo 1
        MDLabel:
            bold: True
            font_style:"H4"
            id: ipTitulo1
            text: root.ipTitulo1
            halign: "center"
            color: 72/255,52/255,23/255,1


        MDBoxLayout:
            orientation:'vertical'
            padding:"10dp"
            # Titulo 2
            MDLabel:
                bold: True
                font_style:"H5"
                text: "Details:"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Max hosts
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Maximum Number of Hosts:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: maxHosts
                font_size: "17dp"
                text: root.maxHosts
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            # Class
            MDLabel:
                bold: True
                font_style:"H6"
                text: "Legacy Class:"
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1
            MDLabel:
                bold: False
                id: Class
                font_size: "17dp"
                text: root.Class
                valign: "top"
                halign: "left"
                color: 72/255,52/255,23/255,1

        AnchorLayout:
            padding: ['0dp', '70dp', '0dp', '0dp']
            MDRaisedButton:
                id: btn_calculate
                text: "Back to selections" 
                bold: True
                font_style: "H5"
                text_color:255/255, 255/255, 255/255, 1
                md_bg_color: 122/255, 177/255, 55/255, 1
                halign: "center"
                on_press:
                    app.root.current = "choose"
                    root.manager.transition.direction = "right"